﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data.SqlClient;
using System.Data;

public partial class Sorting : System.Web.UI.Page
{
    SqlConnection con = new SqlConnection("DataBase=ENGSOFT;User id=sa;Password=P@ssword9");
    SqlDataAdapter da;
    DataSet ds;
    DataTable dt;
    SqlCommand cmd;
    int DeptNo = 1;

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            Bind_GV();
        }
    }
    protected void Bind_GV()
    {
        cmd = new SqlCommand("Get_Employees", con);
        cmd.CommandType = CommandType.StoredProcedure;
        cmd.Parameters.AddWithValue("@DeptNo", DeptNo);
        dt = new DataTable();

        try
        {
            con.Open();
            da = new SqlDataAdapter(cmd);
            da.Fill(dt);
            if (dt.Rows.Count > 0)
            {
                GV.DataSource = dt;
                GV.DataBind();
            }
            else
            {
                DataRow dr = dt.NewRow();

                dt.Rows.Add(dr);
                dt.AcceptChanges();
                GV.DataSource = dt;
                GV.DataBind();
                GV.Rows[0].Visible = false;
            }
            ViewState["dt"] = dt;
        }
        catch (Exception ex)
        {

        }
        finally
        {
            con.Close();
            con.Dispose();
        }
    }
    
    protected void GV_Sorting(object sender, GridViewSortEventArgs e)
    {
        if (ViewState["dt"] != null)
            dt = ViewState["dt"] as DataTable;
        SortDirection dir = SortDirection.Ascending;
        if (ViewState["dir"] != null)
            dir = (SortDirection)ViewState["dir"];
        string sortingDirection = string.Empty; 
        if (dir == SortDirection.Ascending) 
        { 
            dir = SortDirection.Descending; 
            sortingDirection = "Desc"; 
        } 
        else 
        { 
            dir = SortDirection.Ascending; 
            sortingDirection = "Asc"; 
        }
        ViewState["dir"] = dir;
        DataView dv = dt.DefaultView;
        dv.Sort = e.SortExpression + " " + sortingDirection;
 
        GV.DataSource = dv; 
        GV.DataBind(); 

    }
}